####  works procedurally
#### only aiToon

import maya.cmds as cmds

def procedural():
    #  adds attributes to shape nodes of selected objects
    selected = cmds.ls(sl=True,long=True)
    print(len(selected))
    for obj in selected:
        shape_node = cmds.listRelatives(obj, shapes=True)
        print(shape_node)
        #  creates attributes on shape node
        cmds.addAttr(shape_node[0], longName='mtoa_constant_emission', niceName='Emission', at='float', dv=1 )
        cmds.addAttr(shape_node[0], longName='mtoa_constant_emission_color', niceName='Emission_Color', usedAsColor=True,
                     at='float3' )
        cmds.addAttr(shape_node[0], longName='red', attributeType='float', parent='mtoa_constant_emission_color',
                     dv = 1 )
        cmds.addAttr(shape_node[0], longName='green', attributeType='float', parent='mtoa_constant_emission_color',
                     dv = 0 )
        cmds.addAttr(shape_node[0], longName='blue', attributeType='float', parent='mtoa_constant_emission_color',
                     dv = 1 )
        cmds.addAttr(shape_node[0], longName='mtoa_constant_color_A', niceName='Color_A', usedAsColor=True,
                     attributeType='float3')
        cmds.addAttr(shape_node[0], longName='R', attributeType='float', parent='mtoa_constant_color_A', dv=1)
        cmds.addAttr(shape_node[0], longName='G', attributeType='float', parent='mtoa_constant_color_A', dv=0)
        cmds.addAttr(shape_node[0], longName='B', attributeType='float', parent='mtoa_constant_color_A', dv=1)
        cmds.addAttr(shape_node[0], longName='mtoa_constant_color_B', niceName='Color_B', usedAsColor=True,
                     attributeType='float3')
        cmds.addAttr(shape_node[0], longName='Red', attributeType='float', parent='mtoa_constant_color_B')
        cmds.addAttr(shape_node[0], longName='Green', attributeType='float', parent='mtoa_constant_color_B')
        cmds.addAttr(shape_node[0], longName='Blue', attributeType='float', parent='mtoa_constant_color_B', dv=1)
        cmds.addAttr(shape_node[0], longName='mtoa_constant_color_C', niceName='Color_C', usedAsColor=True,
                     attributeType='float3')
        cmds.addAttr(shape_node[0], longName='rojo', attributeType='float', parent='mtoa_constant_color_C',
                     dv=0.0493827)
        cmds.addAttr(shape_node[0], longName='verde', attributeType='float', parent='mtoa_constant_color_C',
                     dv=0.0493827)
        cmds.addAttr(shape_node[0], longName='azul', attributeType='float', parent='mtoa_constant_color_C',
                     dv=0.0493827)
        cmds.addAttr(shape_node[0], longName='mtoa_constant_color_D', niceName='Color_D', usedAsColor=True,
                     attributeType='float3')
        cmds.addAttr(shape_node[0], longName='Rojo', attributeType='float', parent='mtoa_constant_color_D', dv=1)
        cmds.addAttr(shape_node[0], longName='Verde', attributeType='float', parent='mtoa_constant_color_D', dv=1)
        cmds.addAttr(shape_node[0], longName='Azul', attributeType='float', parent='mtoa_constant_color_D', dv=1)
        cmds.addAttr(shape_node[0], ln = 'mtoa_constant_roughVal', niceName = 'Rough_Val', at = 'float', dv=1, min=0.0,
                     max=1)
        cmds.addAttr(shape_node[0], ln = 'mtoa_constant_bumpVal', nn = 'Bump_Val', at = 'float', dv = 1, min = 0,
                     max = 1)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_noiseAmp', nn='Noise_Amplitude', at='float', dv=5, min=0, max=10)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_dispAmp1', nn='Displacement_Amplitude1', at='float', dv=0.9,
                     min=0, max=10)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_dispAmp2', nn='Displacement_Amplitude2', at='float', dv=0, min=0,
                     max=10)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_noiseFreq', nn='Noise_Frequency', at='float', dv=0.5, min=0,
                     max=10)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_dispFreq1', nn='Displacement_Frequency1', at='float', dv=0.9,
                     min=0, max=10)
        cmds.addAttr(shape_node[0], ln='mtoa_constant_dispFreq2', nn='Displacement_Frequency2', at='float', dv=0.8,
                     min=0, max=10)

    #  creates material, OSL nodes, and makes proper connections
    cmds.shadingNode('aiToon', asShader=True)
    cmds.select(selected)
    cmds.hyperShade(assign='aiToon1')
    cmds.rename('aiToon1', 'aiToon_custom_SN')
    cmds.polySphere(name='null')
    cmds.listRelatives('null', shapes=True)
    cmds.shadingNode('aiOslShader', n='aiOslColor', asShader=True)
    cmds.connectAttr('aiOslColor.outValue', 'aiToon_custom_SN.baseColor')
    cmds.select('null')
    cmds.addAttr(ln='OSL_color_code', dt='string')
    cmds.setAttr('null.OSL_color_code', typ='string')
    cmds.connectAttr('null.OSL_color_code', 'aiOslColor.code')
    cmds.hide('null')
    cmds.setAttr('null.OSL_color_code', 'shader base\n\n(\n\noutput color resultDiffuse = 1\n\n)\n\n{\n    color A = 0;\n    color B = 0;\n    color C = 0;\n    color D = 0;\n    float DispNoise1 = 0;\n    float DispNoise2 = 0;\n    float Noise = 0;\n    \n    //sliders to control specular roughness and bump intensities\n    float roughVal = 0.5;\n    float bumpVal = 0.5;\n\n    //sliders to control amplitude of noise\n    float noise_amp = 0.5;\n    float disp_amp1 = 0.5;\n    float disp_amp2 = 0.5;\n\n    //sliders to control frequency of noise\n    float noise_freq = 0.5;\n    float disp_freq1 = 0.5;\n    float disp_freq2 = 0.5;\n    \n    //sliders to turn on/off animation and to control speed of animation\n    float speed = 0.5;\n    int anim = 0;\n    \n    //sliders to manipulate noise\n    float Mask = 1;\n    float Multi = 1;\n    float stretch = 1;\n\n   //each noise placed in object space with amplitude and frequency sliders used. animation variable added for animation\n\n    getattribute(\"color_A\",A);\n    getattribute(\"color_B\",B);\n    getattribute(\"color_C\",C);\n    getattribute(\"color_D\",D);\n    getattribute(\"dispAmp1\", disp_amp1);\n    getattribute(\"dispAmp2\", disp_amp2);\n    getattribute(\"dispFreq1\", disp_freq1);\n    getattribute(\"dispFreq2\", disp_freq2);\n    getattribute(\"noiseAmp\", noise_amp);\n    getattribute(\"noiseFreq\", noise_freq);\n\n   color dispNoise1 = mix(1.0, noise(\"perlin\",(transform(\"object\",P) * disp_freq1)+(time*speed*(anim*.3))), disp_amp1);\n   color dispNoise2 = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * disp_freq2)+(time*speed*(anim*.3))), disp_amp2);\n   color Noize = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * noise_freq)+(time*speed*(anim*.3))), noise_amp);\n   color mainColor = (mix((A*C)*(10*dispNoise1[2]),B*dispNoise2[1],dispNoise1[2]*dispNoise2[0]));\n\n   resultDiffuse = mainColor;\n}', typ = 'string')
    cmds.shadingNode( 'aiOslShader', n='aiOslEmission', asShader=True )
    cmds.connectAttr( 'aiOslEmission.outValue', 'aiToon_custom_SN.emission' )
    cmds.select('null')
    cmds.addAttr(ln = 'OSL_emisison_code', dt = 'string')
    cmds.connectAttr( 'null.OSL_emisison_code', 'aiOslEmission.code' )
    cmds.setAttr('null.OSL_emisison_code','shader base\n\n(\n\noutput color resultEmiss = 1\n\n)\n\n{\n\ncolor myFloat = 1;\n\ngetattribute(\"emission\",myFloat);\n\nresultEmiss = myFloat;\n\n}', typ = 'string')
    cmds.shadingNode( 'aiOslShader', n='aiOslEmissionColor', asShader=True )
    cmds.connectAttr( 'aiOslEmissionColor.outValue', 'aiToon_custom_SN.emissionColor' )
    cmds.select('null')
    cmds.addAttr(ln = 'OSL_emisison_color_code', dt = 'string')
    cmds.setAttr( 'null.OSL_emisison_color_code', typ = 'string' )
    cmds.connectAttr( 'null.OSL_emisison_color_code', 'aiOslEmissionColor.code' )
    cmds.setAttr('null.OSL_emisison_color_code', 'shader base\n\n(\n\noutput color resultDiffuse = 1\n\n)\n\n{\n    color A = 0;\n    color B = 0;\n    color C = 0;\n    color D = 0;\n    float DispNoise1 = 0;\n    float DispNoise2 = 0;\n    float Noise = 0;\n    \n    //sliders to control specular roughness and bump intensities\n    float roughVal = 0.5;\n    float bumpVal = 0.5;\n\n    //sliders to control amplitude of noise\n    float noise_amp = 0.5;\n    float disp_amp1 = 0.5;\n    float disp_amp2 = 0.5;\n\n    //sliders to control frequency of noise\n    float noise_freq = 0.5;\n    float disp_freq1 = 0.5;\n    float disp_freq2 = 0.5;\n    \n    //sliders to turn on/off animation and to control speed of animation\n    float speed = 0.5;\n    int anim = 0;\n    \n    //sliders to manipulate noise\n    float Mask = 1;\n    float Multi = 1;\n    float stretch = 1;\n\n   //each noise placed in object space with amplitude and frequency sliders used. animation variable added for animation\n\n    getattribute(\"color_A\",A);\n    getattribute(\"color_B\",B);\n    getattribute(\"color_C\",C);\n    getattribute(\"color_D\",D);\n    getattribute(\"dispAmp1\", disp_amp1);\n    getattribute(\"dispAmp2\", disp_amp2);\n    getattribute(\"dispFreq1\", disp_freq1);\n    getattribute(\"dispFreq2\", disp_freq2);\n    getattribute(\"noiseAmp\", noise_amp);\n    getattribute(\"noiseFreq\", noise_freq);\n\n   color dispNoise1 = mix(1.0, noise(\"perlin\",(transform(\"object\",P) * disp_freq1)+(time*speed*(anim*.3))), disp_amp1);\n   color dispNoise2 = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * disp_freq2)+(time*speed*(anim*.3))), disp_amp2);\n   color Noize = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * noise_freq)+(time*speed*(anim*.3))), noise_amp);\n   color mainColor = (mix((A*C)*(10*dispNoise1[2]),B*dispNoise2[1],dispNoise1[2]*dispNoise2[0]));\n\n   resultDiffuse = mainColor;\n}', typ = 'string')
    cmds.shadingNode( 'aiOslShader', n='aiOslRoughness', asShader=True )
    cmds.connectAttr( 'aiOslRoughness.outValue', 'aiToon_custom_SN.specularRoughness' )
    cmds.select('null')
    cmds.addAttr(ln = 'OSL_roughness_code', dt = 'string')
    cmds.setAttr( 'null.OSL_roughness_code', typ = 'string' )
    cmds.connectAttr( 'null.OSL_roughness_code', 'aiOslRoughness.code' )
    cmds.setAttr('null.OSL_roughness_code', 'shader base\n\n(\n\noutput color resultRough = 1\n\n)\n\n{\n\n    float roughVal = 1;\n    float bumpVal = 0.5;\n\n    //sliders to control amplitude of noise\n    float noise_amp = 10;\n    float disp_amp1 = 0.5;\n    float disp_amp2 = 0.5;\n\n    //sliders to control frequency of noise\n    float noise_freq = 1;\n    float disp_freq1 = 0.5;\n    float disp_freq2 = 0.5;\n    \n    //sliders to turn on/off animation and to control speed of animation\n    float speed = 0.5;\n    int anim = 0;\n    \n    //sliders to manipulate noise\n    float Mask = 1;\n    float Multi = 1;\n    float stretch = 1;\n\n   //each noise placed in object space with amplitude and frequency sliders used. animation variable added for animation\n\n    getattribute(\"roughVal\", roughVal);\n    getattribute(\"dispAmp1\", disp_amp1);\n    getattribute(\"dispAmp2\", disp_amp2);\n    getattribute(\"dispFreq1\", disp_freq1);\n    getattribute(\"dispFreq2\", disp_freq2);\n    getattribute(\"noiseAmp\", noise_amp);\n    getattribute(\"noiseFreq\", noise_freq);\n\n   color dispNoise1 = mix(1.0, noise(\"perlin\",(transform(\"object\",P) * disp_freq1)+(time*speed*(anim*.3))), disp_amp1);\n   color dispNoise2 = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * disp_freq2)+(time*speed*(anim*.3))), disp_amp2);\n   color Noise = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * noise_freq)+(time*speed*(anim*.3))), noise_amp);\n   color specRoughness = roughVal*(dispNoise1[2]*dispNoise2[1]*Noise[0]);\n    resultRough = specRoughness;\n}', typ = 'string')
    cmds.shadingNode( 'aiOslShader', n='aiOslBump', asShader=True )
    cmds.shadingNode('bump2d', asShader = True)
    cmds.connectAttr( 'aiOslBump.outValue', 'bump2d1.bumpValue' )
    cmds.connectAttr( 'bump2d1.outNormal', 'aiToon_custom_SN.normalCamera' )
    cmds.select('null')
    cmds.addAttr(ln = 'OSL_bump_code', dt = 'string')
    cmds.setAttr( 'null.OSL_bump_code', typ = 'string' )
    cmds.connectAttr( 'null.OSL_bump_code', 'aiOslBump.code' )
    cmds.setAttr('null.OSL_bump_code', 'shader base\n\n(\n\noutput color resultBump = 1\n\n)\n\n{\n\n    float roughVal = 1;\n    float bumpVal = 0.5;\n\n    //sliders to control amplitude of noise\n    float noise_amp = 10;\n    float disp_amp1 = 0.5;\n    float disp_amp2 = 0.5;\n\n    //sliders to control frequency of noise\n    float noise_freq = 1;\n    float disp_freq1 = 0.5;\n    float disp_freq2 = 0.5;\n    \n    //sliders to turn on/off animation and to control speed of animation\n    float speed = 0.5;\n    int anim = 0;\n    \n    //sliders to manipulate noise\n    float Mask = 1;\n    float Multi = 1;\n    float stretch = 1;\n\n   //each noise placed in object space with amplitude and frequency sliders used. animation variable added for animation\n\n    getattribute(\"roughVal\", roughVal);\n    getattribute(\"dispAmp1\", disp_amp1);\n    getattribute(\"dispAmp2\", disp_amp2);\n    getattribute(\"dispFreq1\", disp_freq1);\n    getattribute(\"dispFreq2\", disp_freq2);\n    getattribute(\"noiseAmp\", noise_amp);\n    getattribute(\"noiseFreq\", noise_freq);\n\n   color dispNoise1 = mix(1.0, noise(\"perlin\",(transform(\"object\",P) * disp_freq1)+(time*speed*(anim*.3))), disp_amp1);\n   color dispNoise2 = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * disp_freq2)+(time*speed*(anim*.3))), disp_amp2);\n   color Noise = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * noise_freq)+(time*speed*(anim*.3))), noise_amp);\n   color Bump = bumpVal*(dispNoise2[0]);\n    resultBump = Bump;\n}', typ = 'string')
    cmds.shadingNode( 'aiOslShader', n='aiOslDisplacement', asShader=True )
    cmds.connectAttr( 'aiOslDisplacement.outValue', 'aiToon1SG.displacementShader' )
    cmds.select('null')
    cmds.addAttr(ln = 'OSL_displacement_code', dt = 'string')
    cmds.setAttr( 'null.OSL_displacement_code', typ = 'string' )
    cmds.connectAttr( 'null.OSL_displacement_code', 'aiOslDisplacement.code' )
    cmds.setAttr('null.OSL_displacement_code', 'shader base\n\n(\n\noutput color resultDisp = 1\n\n)\n\n{\n\n    float roughVal = 1;\n    float bumpVal = 0.5;\n\n    //sliders to control amplitude of noise\n    float noise_amp = 10;\n    float disp_amp1 = 0.5;\n    float disp_amp2 = 0.5;\n\n    //sliders to control frequency of noise\n    float noise_freq = 1;\n    float disp_freq1 = 0.5;\n    float disp_freq2 = 0.5;\n    \n    //sliders to turn on/off animation and to control speed of animation\n    float speed = 0.5;\n    int anim = 0;\n    \n    //sliders to manipulate noise\n    float Mask = 1;\n    float Multi = 1;\n    float stretch = 1;\n\n   //each noise placed in object space with amplitude and frequency sliders used. animation variable added for animation\n\n    getattribute(\"roughVal\", roughVal);\n    getattribute(\"dispAmp1\", disp_amp1);\n    getattribute(\"dispAmp2\", disp_amp2);\n    getattribute(\"dispFreq1\", disp_freq1);\n    getattribute(\"dispFreq2\", disp_freq2);\n    getattribute(\"noiseAmp\", noise_amp);\n    getattribute(\"noiseFreq\", noise_freq);\n\n   color dispNoise1 = mix(1.0, noise(\"perlin\",(transform(\"object\",P) * disp_freq1)+(time*speed*(anim*.3))), disp_amp1);\n   color dispNoise2 = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * disp_freq2)+(time*speed*(anim*.3))), disp_amp2);\n   color Noise = mix(1.0, noise(\"usimplex\",(transform(\"object\",P) * noise_freq)+(time*speed*(anim*.3))), noise_amp);\n   color disp = dispNoise1[2]*(-1*(dispNoise2[0])*dispNoise2[0]);\n    resultDisp = disp;\n}', typ = 'string')

#procedural()
